﻿Public Class RNG

    Public Sub New()
        m_seed = 0UI
    End Sub

    Public Sub New(ByVal _SEED As UInt32)
        m_seed = _SEED
    End Sub

    Private m_seed As UInt32

    Public Property Seed() As UInt32
        Get
            Return m_seed
        End Get

        Set(ByVal value As UInt32)
            m_seed = value
        End Set
    End Property

    Public Function [Next]() As UInt32
        Return (&H41C64E6D * m_seed) + &H6073
    End Function

    Public Function NextNum() As UInt32
        m_seed = [Next]()
        Return m_seed
    End Function

End Class

Public Class GTS_PRNG

    Public Sub New()
        m_seed = 0UI
    End Sub

    Public Sub New(ByVal _SEED As UInt32)
        m_seed = _SEED Or (_SEED << 16)
    End Sub

    Private m_seed As UInt32

    Public Property Seed() As UInt32
        Get
            Return m_seed
        End Get

        Set(ByVal value As UInt32)
            m_seed = value
        End Set
    End Property

    Public Function [Next]() As UInt32
        Return (m_seed * &H45 + &H1111) And &H7FFFFFFF
    End Function

    Public Function NextNum() As UInt32
        m_seed = [Next]()
        Return (m_seed >> 16) And &HFF
    End Function

End Class